/*

  File LUtrid.h:

  definisce la classe LUtrid, per la soluzione di sistemi lineari nxn
  tridiagonali attraverso la fattorizzazione LU (algoritmo di Thomas).

*/


#ifndef LUtrid_H

#define LUtrid_H

class LUtrid
{

 private:

   int dim;
   double ** mat;
   double * tmp;

 public:

   LUtrid( int );                                            // Costruttore della classe
   ~LUtrid( );                                               // Distruttore della classe
   void luFact( );                                           // Fattorizza LU la matrice
   void luSolve( double *, double * );                       // Risolve un sistema dati i termini noti
   void setDiagonal( double *, double *, double * );         // Definisce la matrice per diagonali
   void setElement( int, int, double );                      // Definisce la matrice per elementi
   double getElement( int , int );                           // Estrae l'elemento i,j

};

#endif
